Package icyllis.modernui.transition

# Class Visibility

java.lang.Object
icyllis.modernui.transition.Transition
icyllis.modernui.transition.Visibility

All Implemented Interfaces:
  `Cloneable`

Direct Known Subclasses:
  `Explode`, `Fade`, `Slide`

public abstract class Visibility extends Transition
This transition tracks changes to the visibility of target views in the start and end scenes. Visibility is determined not just by the `View.setVisibility(int)` state of views, but also whether views exist in the current view hierarchy. The class is intended to be a utility for subclasses such as `Fade`, which use this visibility information to determine the specific animations to run when visibility changes occur. Subclasses should implement one or both of the methods `onAppear(ViewGroup, TransitionValues, int, TransitionValues, int)`, `onDisappear(ViewGroup, TransitionValues, int, TransitionValues, int)` or `onAppear(ViewGroup, View, TransitionValues, TransitionValues)`, `onDisappear(ViewGroup, View, TransitionValues, TransitionValues)`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static @interface`
  `Visibility.Mode`

  ## Nested classes/interfaces inherited from class icyllis.modernui.transition.Transition

  `Transition.EpicenterCallback, Transition.MatchOrder`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `MODE_IN`
  Mode used in `setMode(int)` to make the transition operate on targets that are appearing.
  `static final int`
  `MODE_OUT`
  Mode used in `setMode(int)` to make the transition operate on targets that are disappearing.

  ### Fields inherited from class icyllis.modernui.transition.Transition

  `MATCH_ID, MATCH_INSTANCE, MATCH_ITEM_ID, MATCH_NAME`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Visibility()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `captureEndValues(TransitionValues transitionValues)`
  Captures the values in the end scene for the properties that this transition monitors.
  `void`
  `captureStartValues(TransitionValues transitionValues)`
  Captures the values in the start scene for the properties that this transition monitors.
  `Animator`
  `createAnimator(ViewGroup sceneRoot, TransitionValues startValues, TransitionValues endValues)`
  This method creates an animation that will be run for this transition given the information in the startValues and endValues structures captured earlier for the start and end scenes.
  `int`
  `getMode()`
  Returns whether appearing and/or disappearing Views are supported.
  `String[]`
  `getTransitionProperties()`
  Returns the set of property names used stored in the `TransitionValues` object passed into `Transition.captureStartValues(TransitionValues)` that this transition cares about for the purposes of canceling overlapping animations.
  `boolean`
  `isTransitionRequired(TransitionValues startValues, TransitionValues newValues)`
  Returns whether the transition should create an Animator, based on the values captured during `Transition.captureStartValues(TransitionValues)` and `Transition.captureEndValues(TransitionValues)`.
  `boolean`
  `isVisible(TransitionValues values)`
  Returns whether the view is 'visible' according to the given values object.
  `Animator`
  `onAppear(ViewGroup sceneRoot, TransitionValues startValues, int startVisibility, TransitionValues endValues, int endVisibility)`
  The default implementation of this method does nothing.
  `Animator`
  `onAppear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)`
  The default implementation of this method returns a null Animator.
  `Animator`
  `onDisappear(ViewGroup sceneRoot, TransitionValues startValues, int startVisibility, TransitionValues endValues, int endVisibility)`
  The default implementation of this method does nothing.
  `Animator`
  `onDisappear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)`
  The default implementation of this method returns a null Animator.
  `void`
  `setMode(int mode)`
  Changes the transition to support appearing and/or disappearing Views, depending on `mode`.

  ### Methods inherited from class icyllis.modernui.transition.Transition

  `addListener, addTarget, addTarget, addTarget, addTarget, animate, cancel, clone, createAnimators, end, excludeChildren, excludeChildren, excludeChildren, excludeTarget, excludeTarget, excludeTarget, excludeTarget, getDuration, getEpicenter, getEpicenterCallback, getInterpolator, getName, getPropagation, getStartDelay, getTargetIds, getTargetNames, getTargets, getTargetTypes, getTransitionValues, pause, removeListener, removeTarget, removeTarget, removeTarget, removeTarget, resume, runAnimators, setDuration, setEpicenterCallback, setInterpolator, setMatchOrder, setPropagation, setStartDelay, start, toString`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### MODE_IN

    public static final int MODE_IN
    Mode used in `setMode(int)` to make the transition operate on targets that are appearing. Maybe be combined with `MODE_OUT` to target Visibility changes both in and out.
    See Also:
      - Constant Field Values

  - ### MODE_OUT

    public static final int MODE_OUT
    Mode used in `setMode(int)` to make the transition operate on targets that are disappearing. Maybe be combined with `MODE_IN` to target Visibility changes both in and out.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Visibility

    public Visibility()

- ## Method Details

  - ### setMode

    public void setMode(int mode)
    Changes the transition to support appearing and/or disappearing Views, depending on `mode`.
    Parameters:
      `mode` - The behavior supported by this transition, a combination of `MODE_IN` and `MODE_OUT`.

  - ### getMode

    public int getMode()
    Returns whether appearing and/or disappearing Views are supported.
    Returns:
      whether appearing and/or disappearing Views are supported. A combination of `MODE_IN` and `MODE_OUT`.

  - ### getTransitionProperties

    @Nullable public String[] getTransitionProperties()
    Description copied from class: `Transition`
    Returns the set of property names used stored in the `TransitionValues` object passed into `Transition.captureStartValues(TransitionValues)` that this transition cares about for the purposes of canceling overlapping animations. When any transition is started on a given scene root, all transitions currently running on that same scene root are checked to see whether the properties on which they based their animations agree with the end values of the same properties in the new transition. If the end values are not equal, then the old animation is canceled since the new transition will start a new animation to these new values. If the values are equal, the old animation is allowed to continue and no new animation is started for that transition.

    A transition does not need to override this method. However, not doing so will mean that the cancellation logic outlined in the previous paragraph will be skipped for that transition, possibly leading to artifacts as old transitions and new transitions on the same targets run in parallel, animating views toward potentially different end values.

    Overrides:
      `getTransitionProperties` in class `Transition`
    Returns:
      An array of property names as described in the class documentation for `TransitionValues`. The default implementation returns `null`.

  - ### captureStartValues

    public void captureStartValues(@Nonnull TransitionValues transitionValues)
    Description copied from class: `Transition`
    Captures the values in the start scene for the properties that this transition monitors. These values are then passed as the startValues structure in a later call to `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)` method to determine what, if any, animations, should be run.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Specified by:
      `captureStartValues` in class `Transition`
    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.
    See Also:
      - `Transition.captureEndValues(TransitionValues)`
      - `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`

  - ### captureEndValues

    public void captureEndValues(@Nonnull TransitionValues transitionValues)
    Description copied from class: `Transition`
    Captures the values in the end scene for the properties that this transition monitors. These values are then passed as the endValues structure in a later call to `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)` method to determine what, if any, animations, should be run.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Specified by:
      `captureEndValues` in class `Transition`
    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.
    See Also:
      - `Transition.captureStartValues(TransitionValues)`
      - `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`

  - ### isVisible

    public boolean isVisible(TransitionValues values)
    Returns whether the view is 'visible' according to the given values object. This is determined by testing the same properties in the values object that are used to determine whether the object is appearing or disappearing in the `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)` method. This method can be called by, for example, subclasses that want to know whether the object is visible in the same way that Visibility determines it for the actual animation.
    Parameters:
      `values` - The TransitionValues object that holds the information by which visibility is determined.
    Returns:
      True if the view reference by `values` is visible, false otherwise.

  - ### createAnimator

    @Nullable public Animator createAnimator(@Nonnull ViewGroup sceneRoot, @Nullable TransitionValues startValues, @Nullable TransitionValues endValues)
    Description copied from class: `Transition`
    This method creates an animation that will be run for this transition given the information in the startValues and endValues structures captured earlier for the start and end scenes. Subclasses of Transition should override this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    This method is called by the transition's parent (all the way up to the topmost Transition in the hierarchy) with the sceneRoot and start/end values that the transition may need to set up initial target values and construct an appropriate animation. For example, if an overall Transition is a `TransitionSet` consisting of several child transitions in sequence, then some of the child transitions may want to set initial values on target views prior to the overall Transition commencing, to put them in an appropriate state for the delay between that start and the child Transition start time. For example, a transition that fades an item in may wish to set the starting alpha value to 0, to avoid it blinking in prior to the transition actually starting the animation. This is necessary because the scene change that triggers the Transition will automatically set the end-scene on all target views, so a Transition that wants to animate from a different value should set that value prior to returning from this method.

    Additionally, a Transition can perform logic to determine whether the transition needs to run on the given target and start/end values. For example, a transition that resizes objects on the screen may wish to avoid running for views which are not present in either the start or end scenes.

    If there is an animator created and returned from this method, the transition mechanism will apply any applicable duration, startDelay, and interpolator to that animation and start it. A return value of `null` indicates that no animation should run. The default implementation returns null.

    The method is called for every applicable target object, which is stored in the `TransitionValues.view` field.

    Overrides:
      `createAnimator` in class `Transition`
    Parameters:
      `sceneRoot` - The root of the transition hierarchy.
      `startValues` - The values for a specific target in the start scene.
      `endValues` - The values for the target in the end scene.
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.

  - ### onAppear

    @Nullable public Animator onAppear(ViewGroup sceneRoot, TransitionValues startValues, int startVisibility, TransitionValues endValues, int endVisibility)
    The default implementation of this method does nothing. Subclasses should override if they need to create an Animator when targets appear. The method should only be called by the Visibility class; it is not intended to be called from external classes.
    Parameters:
      `sceneRoot` - The root of the transition hierarchy
      `startValues` - The target values in the start scene
      `startVisibility` - The target visibility in the start scene
      `endValues` - The target values in the end scene
      `endVisibility` - The target visibility in the end scene
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.

  - ### onAppear

    @Nullable public Animator onAppear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)
    The default implementation of this method returns a null Animator. Subclasses should override this method to make targets appear with the desired transition. The method should only be called from `onAppear(ViewGroup, TransitionValues, int, TransitionValues, int)`.
    Parameters:
      `sceneRoot` - The root of the transition hierarchy
      `view` - The View to make appear. This will be in the target scene's View hierarchy and will be VISIBLE.
      `startValues` - The target values in the start scene
      `endValues` - The target values in the end scene
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.

  - ### onDisappear

    @Nullable public Animator onDisappear(ViewGroup sceneRoot, TransitionValues startValues, int startVisibility, TransitionValues endValues, int endVisibility)
    The default implementation of this method does nothing. Subclasses should override if they need to create an Animator when targets disappear. The method should only be called by the Visibility class; it is not intended to be called from external classes.
    Parameters:
      `sceneRoot` - The root of the transition hierarchy
      `startValues` - The target values in the start scene
      `startVisibility` - The target visibility in the start scene
      `endValues` - The target values in the end scene
      `endVisibility` - The target visibility in the end scene
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.

  - ### onDisappear

    @Nullable public Animator onDisappear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)
    The default implementation of this method returns a null Animator. Subclasses should override this method to make targets disappear with the desired transition. The method should only be called from `onDisappear(ViewGroup, TransitionValues, int, TransitionValues, int)`.
    Parameters:
      `sceneRoot` - The root of the transition hierarchy
      `view` - The View to make disappear. This will be in the target scene's View hierarchy and will be VISIBLE.
      `startValues` - The target values in the start scene
      `endValues` - The target values in the end scene
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.

  - ### isTransitionRequired

    public boolean isTransitionRequired(@Nullable TransitionValues startValues, @Nullable TransitionValues newValues)
    Description copied from class: `Transition`
    Returns whether the transition should create an Animator, based on the values captured during `Transition.captureStartValues(TransitionValues)` and `Transition.captureEndValues(TransitionValues)`. The default implementation compares the property values returned from `Transition.getTransitionProperties()`, or all property values if `getTransitionProperties()` returns null. Subclasses may override this method to provide logic more specific to the transition implementation.
    Overrides:
      `isTransitionRequired` in class `Transition`
    Parameters:
      `startValues` - the values from captureStartValues, This may be `null` if the View did not exist in the start state.
      `newValues` - the values from captureEndValues. This may be `null` if the View did not exist in the end state.